//******************************************************************************
//! @file $RCSfile: config.h,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ȉۼުėp`Ԑݒ̧
//!		   - iar_can_bootloader
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

#ifndef _CONFIG_H_
#define _CONFIG_H_

//_____ ݸٰ ________________________________________________________________
#ifndef  ENABLE_BIT_DEFINITIONS
#define  ENABLE_BIT_DEFINITIONS
#endif

#include <ioavr.h>
#include "iar_compiler.h"

#if   defined(__AT90CAN128__) || \
      defined(__AT90CAN64__)  || \
      defined(__AT90CAN32__)
#   include "at90canxx_drv.h"
    // 1ڂ̊CӑI:
#   include "dvk90can1_board.h"
    // 2ڂ̊CӑI:
//#   include "stk600_at90canxx_board.h"
#elif defined(__ATmega16M1__) || \
      defined(__ATmega32M1__) || \
      defined(__ATmega32C1__) || \
      defined(__ATmega64M1__) || \
      defined(__ATmega64C1__)
#   include "atmegaxxm1c1_drv.h"
    // 1ڂ̊CӑI:
//#   include "stk524_board.h"
    // 2ڂ̊CӑI:
//#   include "stk600_atmegaxxm1c1_board.h"
    // 3ڂ̊CӑI:
#   include "mc310_board.h"
#else
#   error IAR Embedded Workbench IDE "Project->Options ...->General Options->Targetł̕s޲I"
#endif

//_____ ` ___________________________________________________________________

//---------------- ް ۰ޒ` -----------------------------------------------
#define BOOT_LOADER_SIZE			0x1000		// ޲Ăł̗:4K޲
#define MAX_FLASH_SIZE_TO_ERASE		( FLASH_SIZE - ((U32)(BOOT_LOADER_SIZE)) )

//---------------- ۾` --------------------------------------------------

#define XRAM_END	XRAMEND					// "ioxxx.h"Œ`
#define RAM_END		RAMEND					// "ioxxx.h"Œ`
#define E2_END		E2END					// "ioxxx.h"Œ`
#define FLASH_END	FLASHEND				// "ioxxx.h"ɉ޲ĂŒ`
#define FLASH_SIZE	((U32)(FLASH_END)) + 1	// ޲Ăł̗

// `Ɛ؂ւp̐؂ւ
// ̓`"ioavr.h"ɓnĒ`܂(ƁAFLASHEND, E2ENDȂ)B
#if   defined(__AT90CAN128__)			// __HAS_ELPM__IAR޲IɂĒ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x81		// AT90CANxxxn
# define PRODUCT_NAME		0x97		// 128K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	256			// ޲Ăłׯ ߰ޗe(AT90CANxxx޲ɊւĂ͈)
# define _BOOT_CONF_TYPE_	__farflash  // ް ۰ނ64KȏɊ蓖
# define _RAMPZ_IS_USED_				// ׯ ؂64K޲ĂŎgpꍇRAMPZڼ޽gp܂B


#elif defined(__AT90CAN64__)			// __HAS_ELPM__IAR޲IɂĖ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x81		// AT90CANxxxn
# define PRODUCT_NAME		0x96		// 64K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	256			// ޲Ăłׯ ߰ޗe(AT90CANxxx޲ɊւĂ͈)
# define _BOOT_CONF_TYPE_	__flash		// ް ۰ނ64KȉɊ蓖


#elif defined(__AT90CAN32__)			// __HAS_ELPM__IAR޲IɂĖ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x81		// AT90CANxxxn
# define PRODUCT_NAME		0x95		// 32K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	256			// ޲Ăłׯ ߰ޗe(AT90CANxxx޲ɊւĂ͈)
# define _BOOT_CONF_TYPE_	__flash		// ް ۰ނ64KȉɊ蓖

#elif defined(__ATmega16M1__)			// __HAS_ELPM__IAR޲IɂĖ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x84		// ATmegaxxM1C1n
# define PRODUCT_NAME		0x94		// 16K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	128			// ޲Ăłׯ ߰ޗe
# define _BOOT_CONF_TYPE_	__flash		// ް ۰ނ64KȉɊ蓖

#elif defined(__ATmega32M1__)			// __HAS_ELPM__IAR޲IɂĖ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x84		// ATmegaxxM1C1n
# define PRODUCT_NAME		0x95		// 32K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	128			// ޲Ăłׯ ߰ޗe
# define _BOOT_CONF_TYPE_	__flash		// ް ۰ނ64KȉɊ蓖

#elif defined(__ATmega32C1__)			// __HAS_ELPM__IAR޲IɂĖ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x86		// ATmegaxxM1C1n
# define PRODUCT_NAME		0x95		// 32K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	128			// ޲Ăłׯ ߰ޗe
# define _BOOT_CONF_TYPE_	__flash		// ް ۰ނ64KȉɊ蓖

#elif defined(__ATmega64M1__)			// __HAS_ELPM__IAR޲IɂĖ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x84		// AATmegaxxM1C1n
# define PRODUCT_NAME		0x96		// 64K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	256			// ޲Ăłׯ ߰ޗe
# define _BOOT_CONF_TYPE_	__flash		// ް ۰ނ64KȉɊ蓖

#elif defined(__ATmega64C1__)			// __HAS_ELPM__IAR޲IɂĖ`
# define MANUF_ID			0x1E		// (ATMEL)
# define FAMILY_CODE		0x86		// ATmegaxxM1C1n
# define PRODUCT_NAME		0x96		// 64K޲Ăׯ 
# define PRODUCT_REV		0x00		// 0
# define FLASH_PAGE_SIZE	256			// ޲Ăłׯ ߰ޗe
# define _BOOT_CONF_TYPE_	__flash 	// ް ۰ނ64KȉɊ蓖

#else
# error IAR Embedded Workbench IDE "Project->Options ...->General Options->Targetł̕s޲I"
#endif

#define FOSC				8000

//---------------- CAN` -----------------------------------------------------
//#define CAN_BAUDRATE		500			// KޯĂłްڰ
#define CAN_BAUDRATE		CAN_AUTOBAUD

//******************************************************************************

#endif  // _CONFIG_H_
