//******************************************************************************
//! @file $RCSfile: eeprom_lib.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قAT90CAN128/64/32ATmega16M1/32M1/32C1/64M1/64C1EEPROM
//!		   sٰ݂̑g܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "eeprom_lib.h"
#include "eeprom_drv.h"

//_____ ` ___________________________________________________________________

//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn eeprom_rd_byte
//!
//! ̊֐64K޲Ă܂łEEPROM޲ēǂݍ݂܂B
//!
//! @warning
//!
//! @param:		addr_byte	EEPROM޲Ăǂޱڽ
//!
//! @return:	EEPROMœǂ񂾒l
//------------------------------------------------------------------------------
U8 eeprom_rd_byte(U16 addr_byte)
{
  return (Eeprom_rd_byte(addr_byte));
}

//------------------------------------------------------------------------------
//  @fn eeprom_wr_byte
//!
//! ̊֐64K܂łEEPROM޲ď݂܂B
//!
//! @warning
//!
//! @param:	addr_byte	޲ĂEEPROM̱ڽ
//!			value		EEPROMɏ߂̒l
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void eeprom_wr_byte(U16 addr_byte, U8 value)
{
  Eeprom_wr_byte(addr_byte, value);
  Eeprom_prog_completed;
}

//------------------------------------------------------------------------------
//  @fn eeprom_rd_block
//!
//! ̊֐EEPROM65535޲(64K޲-1)܂ł̓ǂݍ݂܂B
//!
//! @warning:	1 - ̊֐͊S64K޲Ăڽwł܂񂪁A޲64K
//!					޲Ă܂ł̓]ɏՕ邱Ƃł܂B
//!
//! @param:	src		EEPROMްǂފJnڽ
//!			*dest	ް̱ڽ
//!			n		ǂ޲Đ
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void eeprom_rd_block(U16 src, U8* dest, U16 n)
{
  for (; n != 0 ; n--)
  {
	SRAM_BYTE_AT(dest) = eeprom_rd_byte(src);
	src++; dest++;
  }
}
//------------------------------------------------------------------------------
//  @fn eeprom_wr_block
//!
//! ̊֐EEPROM65535޲(64K޲-1)܂ł݂̏܂B
//!
//! @warning:	1 - ̊֐͊S64K޲Ăڽwł܂񂪁A޲64K
//!					޲Ă܂ł̓]ɏՕ邱Ƃł܂B
//!
//! @param:	*src	ް̱ڽ
//!			dest	ްEEPROM̊Jnڽ
//!			n		޲Đ
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void eeprom_wr_block(U8* src, U16 dest, U16 n)
{
  for (; n != 0 ; n--)
  {
	eeprom_wr_byte(dest,SRAM_BYTE_AT(src));
	src++; dest++;
  }
}

//------------------------------------------------------------------------------
//  @fn eeprom_full_erase
//!
//! ̊֐EEPROMŜ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void eeprom_full_erase(void)
{
  U16 addr;

  for(addr = 0; addr < (U16)(E2_END+1); addr++)
  {
	if ((Eeprom_rd_byte(addr)) != EEPROM_BLANK_BYTE)
	{
	  Eeprom_wr_byte(addr, EEPROM_BLANK_BYTE);
	  Eeprom_prog_completed;
	}
  }
}
