//******************************************************************************
//! @file $RCSfile: can_drv.h,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قAT90CAN128/64/32ATmega16M1/32M1/32C1/64M1/64C1pCAN
//!		   ϸ۾ق̌^ϸۂ܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

#ifndef _CAN_DRV_H_
#define _CAN_DRV_H_

//_____ ݸٰ ________________________________________________________________

//_____ ` ___________________________________________________________________

  // ----------
#ifndef FOSC
#  error "config.h"̧قFOSC`Ȃ΂Ȃ܂B
#endif
  // ----------
#ifndef CAN_BAUDRATE
#  error "config.h"̧قCAN_BAUDRATE`Ȃ΂Ȃ܂B
#endif
  // ----------
#if FOSC == 16000				//!< Fclkio=16MHz, Tclkio=62.5ns
#   if   CAN_BAUDRATE == 100		//!< -- 100Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x12		// Tscl =~10Tclkio=625ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 125		//!< -- 125Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x0E		// Tscl=~8Tclkio=500ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 200		//!< -- 200Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x08		// Tscl=~5Tclkio=312.5ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 250		//!< -- 250Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x06		// Tscl=~4Tclkio=250ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 500		//!< -- 500Kb/s, ~8Tscl, 75%ō̎
#       define CONF_CANBT1	0x06		// Tscl=~4Tclkio=250ns
#       define CONF_CANBT2	0x04		// Tsync=~1Tscl, Tprs=~3Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x13		// Tpsh1=~2Tscl, Tpsh2=~2Tscl, 3̎_
#   elif CAN_BAUDRATE == 1000		//!< -- 1Mb/s, ~8Tscl, 75%ō̎
#       define CONF_CANBT1	0x02		// Tscl=~2Tclkio=125ns
#       define CONF_CANBT2	0x04		// Tsync=~1Tscl, Tprs=~3Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x13		// Tpsh1=~2Tscl, Tpsh2=~2Tscl, 3̎_
#   elif CAN_BAUDRATE == CAN_AUTOBAUD	// ̧ٓ̌ŏ
#       define CONF_CANBT1	0x00		// gp
#       define CONF_CANBT2	0x00		// gp
#       define CONF_CANBT3	0x00		// gp
#   else
#       error CAN_BAUDRATEl"can_drv.h"̧ٓł͂܂B
#   endif

#elif FOSC == 12000				//!< Fclkio = 12MHz, Tclkio=83.333ns
#   if   CAN_BAUDRATE == 100		//!< -- 100Kb/s, ~20Tscl, 75%ō̎
#       define CONF_CANBT1	0x0A		// Tscl=~6Tclkio=500ns
#       define CONF_CANBT2	0x0E		// Tsync=~1Tscl, Tprs=~8Tscl, Tsjw=1xTscl
#       define CONF_CANBT3	0x4B		// Tpsh1=~6Tscl, Tpsh2=~5Tscl, 3̎_
#   elif CAN_BAUDRATE == 125		//!< -- 125Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x0A		// Tscl=~6Tclkio=500ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 200		//!< -- 200Kb/s, ~20Tscl, 75%ō̎
#       define CONF_CANBT1	0x04		// Tscl=~3Tclkio=250ns
#       define CONF_CANBT2	0x0E		// Tsync=~1Tscl, Tprs=~8Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x4B		// Tpsh1=~6Tscl, Tpsh2=~5Tscl, 3̎_
#   elif CAN_BAUDRATE == 250		//!< -- 250Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x04		// Tscl=~3Tclkio=250ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 500		//!< -- 500Kb/s, ~12Tscl, 75%ō̎
#       define CONF_CANBT1	0x02		// Tscl=~2Tclkio=166.666ns
#       define CONF_CANBT2	0x08		// Tsync=~1Tscl, Tprs=~5Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x25		// Tpsh1=~3Tscl, Tpsh2=~3Tscl, 3̎_
#   elif CAN_BAUDRATE == 1000		//!< -- 1Mb/s, ~12Tscl, 75%ō̎
#       define CONF_CANBT1	0x00		// Tscl=~1Tclkio=83.333ns
#       define CONF_CANBT2	0x08		// Tsync=~1Tscl, Tprs=~5Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x25		// Tpsh1=~3Tscl, Tpsh2=~3Tscl, 3̎_
#   elif CAN_BAUDRATE == CAN_AUTOBAUD	// ̧ٓ̌ŏ
#       define CONF_CANBT1	0x00		// gp
#       define CONF_CANBT2	0x00		// gp
#       define CONF_CANBT3	0x00		// gp
#   else
#       error CAN_BAUDRATEl"can_drv.h"̧ٓł͂܂B
#   endif

#elif FOSC == 8000				//!< Fclkio=8MHz, Tclkio=125ns
#   if   CAN_BAUDRATE == 100		//!< -- 100Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x08		// Tscl=~5Tclkio=625ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 125		//!< -- 125Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x06		// Tscl=~4Tclkio=500ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 200		//!< -- 200Kb/s, ~20Tscl, 75%ō̎
#       define CONF_CANBT1	0x02		// Tscl=~2Tclkio=250ns
#       define CONF_CANBT2	0x0E		// Tsync=~1Tscl, Tprs=~8Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x4B		// Tpsh1=~6Tscl, Tpsh2=~5Tscl, 3̎_
#   elif CAN_BAUDRATE == 250		//!< -- 250Kb/s, ~16Tscl, 75%ō̎
#       define CONF_CANBT1	0x02		// Tscl=~2Tclkio=250ns
#       define CONF_CANBT2	0x0C		// Tsync=~1Tscl, Tprs=~7Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x37		// Tpsh1=~4Tscl, Tpsh2=~4Tscl, 3̎_
#   elif CAN_BAUDRATE == 500		//!< -- 500Kb/s, ~8Tscl, 75%ō̎
#       define CONF_CANBT1	0x02		// Tscl=~2Tclkio=250ns
#       define CONF_CANBT2	0x04		// Tsync=~1Tscl, Tprs=~3Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x13		// Tpsh1=~2Tscl, Tpsh2=~2Tscl, 3̎_
#   elif CAN_BAUDRATE == 1000		//!< -- 1Mb/s, ~8Tscl, 75%ō̎
#       define CONF_CANBT1	0x00		// Tscl=~1Tclkio=125ns
#       define CONF_CANBT2	0x04		// Tsync=~1Tscl, Tprs=~3Tscl, Tsjw=~1Tscl
#       define CONF_CANBT3	0x13		// Tpsh1=~2Tscl, Tpsh2=~2Tscl, 3̎_
#   elif CAN_BAUDRATE == CAN_AUTOBAUD	// ̧ٓ̌ŏ
#       define CONF_CANBT1	0x00		// gp
#       define CONF_CANBT2	0x00		// gp
#       define CONF_CANBT3	0x00		// gp
#   else
#       error CAN_BAUDRATEl"can_drv.h"̧ٓł͂܂B
#   endif

#else
#   error FOSCl"can_drv.h"̧ٓł͂܂B
#endif
  // ----------
  //! "can_bit_timing()"̍ŏ̊CANؾĂ邱ƂłB
  //! "can_bit_timing()"CAN֎~ɂ܂B
  //! "can_bit_timing()" returns 1 if the setting of CANBTxڼ޽̐ݒ肪
  //! p\̏ꍇ1ACANBTxڼ޽sȏꍇ0Ԃ܂B
#if     CAN_BAUDRATE == CAN_AUTOBAUD
#   define Can_bit_timing(mode)		(can_auto_baudrate(mode) )
#else
#   define Can_bit_timing(mode)		(can_fixed_baudrate(mode))
#endif
  // ----------
#if   defined(__AT90CAN128__) || defined(__AT90CAN64__) || defined(__AT90CAN32__)
#   define CAN_PORT_IN		PIND
#   define CAN_PORT_DIR		DDRD
#   define CAN_PORT_OUT		PORTD
#   define CAN_INPUT_PIN	6
#   define CAN_OUTPUT_PIN	5
#   define NB_MOB			15
#   define Can_clear_mob()	{ U8  volatile *__i_; for (__i_=&CANSTMOB; __i_<&CANSTML; __i_++) { *__i_=0x00 ;}}
#elif defined(__ATmega16M1__) || defined(__ATmega32M1__) || defined(__ATmega32C1__) || defined(__ATmega64M1__) || defined(__ATmega64C1__)
#   define CAN_PORT_IN		PINC
#   define CAN_PORT_DIR		DDRC
#   define CAN_PORT_OUT		PORTC
#   define CAN_INPUT_PIN	3
#   define CAN_OUTPUT_PIN	2
#   define NB_MOB			6
#   define Can_clear_mob()	{ U8  volatile *__i_; for (__i_=&CANSTMOB; __i_<&CANSTMPL; __i_++) { *__i_=0x00 ;}}
#else
#   error IAR Embedded Workbench IDE "Project->Options ...->General Options->Targetł̕s޲I"
#endif

  // ----------
#define ERR_GEN_MSK	((1<<SERG)|(1<<CERG)|(1<<FERG)|(1<<AERG))			//! ʈُ튄荞ݗpՕ
#define INT_GEN_MSK	((1<<BOFFIT)|(1<<BXOK)|(ERR_GEN_MSK))				//! ʊ荞ݗpՕ

#define BRP_MSK		((1<<BRP5)|(1<<BRP4)|(1<<BRP3)|(1<<BRP2)|(1<<BRP1)|(1<<BRP0))	//! CANBT1BRPpՕ
#define SJW_MSK		((1<<SJW1)|(1<<SJW0))								//! CANBT2SJWpՕ
#define PRS_MSK		((1<<PRS2)|(1<<PRS1)|(1<<PRS0))						//! CANBT2PRSpՕ
#define PHS2_MSK	((1<<PHS22)|(1<<PHS21)|(1<<PHS20))					//! CANBT2PHS2pՕ
#define PHS1_MSK	((1<<PHS12)|(1<<PHS11)|(1<<PHS10))					//! CANBT2PSH1pՕ
#define BRP			(BRP0)												//! CANBT1BRPpՕ
#define SJW			(SJW0)												//! CANBT2SJWpՕ
#define PRS			(PRS0)												//! CANBT2PRSpՕ
#define PHS2		(PHS20)												//! CANBT2PHS2pՕ
#define PHS1		(PHS10)												//! CANBT2PHS1pՕ

#define HPMOB_MSK	((1<<HPMOB3)|(1<<HPMOB2)|(1<<HPMOB1)|(1<<HPMOB0))	//! HPMOBMObpՕ
#define MOBNB_MSK	((1<<MOBNB3)|(1<<MOBNB2)|(1<<MOBNB1)|(1<<MOBNB0))	//! CANPAGEMObpՕ

#define ERR_MOB_MSK	((1<<BERR)|(1<<SERR)|(1<<CERR)|(1<<FERR)|(1<<AERR))	//! MObُpՕ
#define INT_MOB_MSK	((1<<TXOK)|(1<<RXOK)|(1<<BERR)|(1<<SERR)|(1<<CERR)|(1<<FERR)|(1<<AERR))	//! MOb荞ݗpՕ

#define CONMOB_MSK	((1<<CONMOB1)|(1<<CONMOB0))							//! MOb`ԐݒpՕ
#define DLC_MSK		((1<<DLC3)|(1<<DLC2)|(1<<DLC1)|(1<<DLC0))			//! ްpՕ
#define CONMOB		(CONMOB0)											//! `ԐݒMOb
#define DLC			(DLC0)												//! ް
  // ----------
#define BRP_MIN		1		//! FOSC̑Ou(TQ)
#define BRP_MAX		64
#define NTQ_MIN		8		//! 1CANޯĂłTQ
#define NTQ_MAX		25
							//! TQł̐^̋敪l
#define PRS_MIN		1		//! `d敪
#define PRS_MAX		8
#define PHS1_MIN	2		//! iK1敪
#define PHS1_MAX	8
#define PHS2_MIN	2		//! iK2敪
#define PHS2_MAX	8
#define SJW_MIN		1		//! 
#define SJW_MAX		4
  // ----------
// "#define NB_MOB"͊ɏŒ`ς(ȉ޲)
#define NB_DATA_MAX		8
#define LAST_MOB_NB		(NB_MOB-1)
#define NO_MOB			0xFF
  // ----------
typedef enum {
		MOB_0,  MOB_1, MOB_2,  MOB_3,  MOB_4,  MOB_5,  MOB_6, MOB_7,
		MOB_8,  MOB_9, MOB_10, MOB_11, MOB_12, MOB_13, MOB_14        } can_mob_t;
  // ----------
#define STATUS_CLEARED			  0x00
  // ----------
#define MOB_NOT_COMPLETED		  0x00												// 0x00
#define MOB_TX_COMPLETED		 (1<<TXOK)											// 0x40
#define MOB_RX_COMPLETED		 (1<<RXOK)											// 0x20
#define MOB_RX_COMPLETED_DLCW	((1<<RXOK)|(1<<DLCW))								// 0xA0
#define MOB_ACK_ERROR			 (1<<AERR)											// 0x01
#define MOB_FORM_ERROR			 (1<<FERR)											// 0x02
#define MOB_CRC_ERROR			 (1<<CERR)											// 0x04
#define MOB_STUFF_ERROR			 (1<<SERR)											// 0x08
#define MOB_BIT_ERROR			 (1<<BERR)											// 0x10
#define MOB_PENDING				((1<<RXOK)|(1<<TXOK))								// 0x60
#define MOB_NOT_REACHED			((1<<AERR)|(1<<FERR)|(1<<CERR)|(1<<SERR)|(1<<BERR))	// 0x1F
#define MOB_DISABLE				  0xFF												// 0xFF
  // ----------
#define MOB_Tx_ENA		1
#define MOB_Rx_ENA		2
#define MOB_Rx_BENA		3
  // ----------

//_____ ϸ ____________________________________________________________________

  // ----------
#define Can_reset()			( CANGCON  =  (1<<SWRES) )
#define Can_enable()		( CANGCON |=  (1<<ENASTB))
#define Can_disable()		( CANGCON &= ~(1<<ENASTB))
  // ----------
#define Can_full_abort()	{ CANGCON |=  (1<<ABRQ); CANGCON &= ~(1<<ABRQ); }
  // ----------
#define Can_conf_bt()		{ CANBT1=CONF_CANBT1; CANBT2=CONF_CANBT2; CANBT3=CONF_CANBT3; }
  // ----------
#define Can_set_mob(mob)		{ CANPAGE = ((mob) << 4);}
#define Can_set_mask_mob()		{  CANIDM4=0xFF; CANIDM3=0xFF; CANIDM2=0xFF; CANIDM1=0xFF; }
#define Can_clear_mask_mob()	{  CANIDM4=0x00; CANIDM3=0x00; CANIDM2=0x00; CANIDM1=0x00; }
#define Can_clear_status_mob()	{ CANSTMOB=0x00; }
//#define Can_clear_mob()		{ CANSTMOB=0x00; CANCDMOB=0x00; \
//								  CANIDT4=0x00; CANIDT3=0x00; CANIDT2=0x00; CANIDT1=0x00; \
//								  CANIDM4=0x00; CANIDM3=0x00; CANIDM2=0x00; CANIDM1=0x00; }
  // ----------
#define Can_mob_abort()		( DISABLE_MOB )
  // ----------
#define Can_set_dlc(dlc)	( CANCDMOB |= (dlc)        )
#define Can_set_ide()		( CANCDMOB |= (1<<IDE)     )
#define Can_set_rtr()		( CANIDT4  |= (1<<RTRTAG)  )
#define Can_set_rplv()		( CANCDMOB |= (1<<RPLV)    )
  // ----------
#define Can_clear_dlc()		( CANCDMOB &= ~DLC_MSK     )
#define Can_clear_ide()		( CANCDMOB &= ~(1<<IDE)    )
#define Can_clear_rtr()		( CANIDT4  &= ~(1<<RTRTAG) )
#define Can_clear_rplv()	( CANCDMOB &= ~(1<<RPLV)   )
  // ----------
#define DISABLE_MOB				( CANCDMOB &= (~CONMOB_MSK) )
#define Can_config_tx()			{ DISABLE_MOB; CANCDMOB |= (MOB_Tx_ENA  << CONMOB); }
#define Can_config_rx()			{ DISABLE_MOB; CANCDMOB |= (MOB_Rx_ENA  << CONMOB); }
#define Can_config_rx_buffer()	{              CANCDMOB |= (MOB_Rx_BENA << CONMOB); }
  // ----------
#define Can_get_dlc()		((CANCDMOB &  DLC_MSK)     >> DLC   )
#define Can_get_ide()		((CANCDMOB &  (1<<IDE))    >> IDE   )
#define Can_get_rtr()		((CANIDT4  &  (1<<RTRTAG)) >> RTRTAG)
  // ----------
#define Can_set_rtrmsk()	( CANIDM4 |= (1<<RTRMSK) )
#define Can_set_idemsk()	( CANIDM4 |= (1<<IDEMSK) )
  // ----------
#define Can_clear_rtrmsk()	( CANIDM4 &= ~(1<<RTRMSK) )
#define Can_clear_idemsk()	( CANIDM4 &= ~(1<<IDEMSK) )
  // ----------
	//!< Wʕ[擾
#define Can_get_std_id(identifier)	{ *((U8 *)(&(identifier))+1) =  CANIDT1>>5              ; \
									  *((U8 *)(&(identifier))  ) = (CANIDT2>>5)+(CANIDT1<<3); }
    // ----------
	//!< gʕ[擾
#define Can_get_ext_id(identifier)	{ *((U8 *)(&(identifier))+3) =  CANIDT1>>3              ; \
									  *((U8 *)(&(identifier))+2) = (CANIDT2>>3)+(CANIDT1<<5); \
									  *((U8 *)(&(identifier))+1) = (CANIDT3>>3)+(CANIDT2<<5); \
									  *((U8 *)(&(identifier))  ) = (CANIDT4>>3)+(CANIDT3<<5); }
  // ----------
	//!< Wʍ\z
#define CAN_SET_STD_ID_10_4(identifier)	(((*((U8 *)(&(identifier))+1))<<5)+((* (U8 *)(&(identifier)))>>3))
#define CAN_SET_STD_ID_3_0( identifier)	(( * (U8 *)(&(identifier))   )<<5)
  // ----------
	//!< Wʕ[ݒ
#define Can_set_std_id(identifier)	{ CANIDT1   = CAN_SET_STD_ID_10_4(identifier); \
									  CANIDT2   = CAN_SET_STD_ID_3_0( identifier); \
									  CANCDMOB &= (~(1<<IDE))                    ; }
  // ----------
	//!< WʎՕݒ
#define Can_set_std_msk(mask)		{ CANIDM1   = CAN_SET_STD_ID_10_4(mask); \
									  CANIDM2   = CAN_SET_STD_ID_3_0( mask); }
  // ----------
	//!< gʍ\z
#define CAN_SET_EXT_ID_28_21(identifier)	(((*((U8 *)(&(identifier))+3))<<3)+((*((U8 *)(&(identifier))+2))>>5))
#define CAN_SET_EXT_ID_20_13(identifier)	(((*((U8 *)(&(identifier))+2))<<3)+((*((U8 *)(&(identifier))+1))>>5))
#define CAN_SET_EXT_ID_12_5( identifier)	(((*((U8 *)(&(identifier))+1))<<3)+((* (U8 *)(&(identifier))   )>>5))
#define CAN_SET_EXT_ID_4_0(  identifier)	((* (U8 *)(&(identifier))   )<<3)
  // ----------
	//!< gʕ[ݒ
#define Can_set_ext_id(identifier)	{ CANIDT1   = CAN_SET_EXT_ID_28_21(identifier); \
									  CANIDT2   = CAN_SET_EXT_ID_20_13(identifier); \
									  CANIDT3   = CAN_SET_EXT_ID_12_5( identifier); \
									  CANIDT4   = CAN_SET_EXT_ID_4_0(  identifier); \
									  CANCDMOB |= (1<<IDE);                         }
  // ----------
	//!< gʎՕݒ
#define Can_set_ext_msk(mask)		{ CANIDM1   = CAN_SET_EXT_ID_28_21(mask); \
									  CANIDM2   = CAN_SET_EXT_ID_20_13(mask); \
									  CANIDM3   = CAN_SET_EXT_ID_12_5( mask); \
									  CANIDM4   = CAN_SET_EXT_ID_4_0(  mask); }
  // ----------

//_____ 錾 ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn can_clear_all_mob
//!
//! ̊֐Ұޯ̓e܂B
//! Can_clear_mob()ϸۂpMOb[LAST_MOB_NB]MOb[0]ްFIFO
//! ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
extern  void can_clear_all_mob(void);

//------------------------------------------------------------------------------
//  @fn can_get_mob_free
//!
//! ̊֐͍ŏɗp\MObԍA܂p\MobȂꍇ0xFFԂ
//! ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	MOb
//!			- MOb[0]`MOb[LAST_MOB_NB]
//!			- MObȂ̏ꍇ0xFF
extern  U8 can_get_mob_free(void);

//------------------------------------------------------------------------------
//  @fn can_get_mob_status
//!
//! ̊֐RXOKTXOK׸ނ1ݒ肳Ăꍇ"MObƊ"A܂RXOK
//! TXOKSݒ肳ĂȂꍇ"MOBƖ"̏Ԃ܂B
//! OāÅ֐MOb`Ԑݒ肳Ă邩ۂ𒲂ׁAMOb`Ԑݒ肳
//! ȂꍇA֐"MOB_DISABLE"Ԃ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	MOb
//!			-  MOB_NOT_COMPLETED
//!			-  MOB_TX_COMPLETED
//!			-  MOB_RX_COMPLETED
//!			-  MOB_RX_DLC_WARNING
//!			-  MOB_DISABLE
//!			܂͈ȉُ̈Ƃ̑gݍ킹łׂłB
//!			-  MOB_ACK_ERROR
//!			-  MOB_FORM_ERROR
//!			-  MOB_CRC_ERROR
//!			-  MOB_STUFF_ERROR
//!			-  MOB_BIT_ERROR
extern  U8 can_get_mob_status(void);

//------------------------------------------------------------------------------
//  @fn can_get_data
//!
//! ̊֐͑IMObҰƂēnꂽڽް𕡎ʂ܂B
//!
//! @warning	Ȃ
//!
//! @param	CANү ް ڽ
//!
//! @return	Ȃ
extern  void can_get_data(U8* p_can_message_data);

//------------------------------------------------------------------------------
//  @fn can_auto_baudrate
//!
//! ̊֐CAN޽ł̒ʐM()ꍇɂꎩgCANBTxڼ޽ݒ
//! ܂B
//!
//! @warning	@\͖Ă܂B
//!
//! @param	Kvȕ]
//!			0: 葬ްڰĂ]Jn
//!			1: CANBTxڼ޽eŕ]Jn
//!
//! @return	ްڰď
//!			0: ޯ ݸތ`Ԑݒ̒Ts
//!			1: ްڰĂ͎s܂B
extern  U8 can_auto_baudrate(U8 eval);

//------------------------------------------------------------------------------
//  @fn can_fixed_baudrate
//!
//! ̊֐͗\ߒ`ꂽlACONF_CANBT1, CONF_CANBT2, CONF_CANBT3CANBTxڼ
//! ݒ肵܂B
//!
//! @warning
//!
//! @param	(gp!)
//!
//! @return	ްڰď
//!			Œ=1: ްڰĂ͎s܂B
extern U8 can_fixed_baudrate(U8 eval);

//******************************************************************************

#endif // _CAN_DRV_H_
