//**************************************************************************
//! @file $RCSfile: compiler.h,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧ق͂ǂ̿ ̧قłIAR AVRׂ߲ɂď邱Ƃł
//!		   ̂ۏ؂邽߂ATMELp߲ ܰނ()`܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//**************************************************************************

#ifndef _COMPILER_H_
#define _COMPILER_H_

//_____ 錾 ___________________________________________________________________

typedef unsigned char		Bool;

typedef unsigned char		U8 ;
typedef unsigned short		U16;
typedef unsigned long		U32;
typedef unsigned long long	U64;
typedef char				S8 ;
typedef short				S16;
typedef long				S32;
typedef long long			S64;

typedef union
{
  U16 h   ;		// ƂĂh
  U8  b[2];		// ޲ĂƂĂb
} Union16;

typedef union
{
  U32 w   ;     // ƂĂw
  U16 h[2];     // ƂĂh
  U8  b[4];     // ޲ĂƂĂb
} Union32;

typedef union
{
  U64 d   ;     // {ƂĂd
  U32 w[2];     // w as WORD
  U16 h[4];     // ƂĂh
  U8  b[8];     // ޲ĂƂĂb
} Union64;

//_____ ϸ ____________________________________________________________________

//! ̗LpϸۂȂ
#define Max(a, b)				( (a)>(b) ? (a) : (b) )			// abԂ̍ő擾
#define Min(a, b)				( (a)<(b) ? (a) : (b) )			// abԂ̍ŏ擾
#define Align_up(val, n)		( ((val)+(n)-1) & ~((n)-1) )	// (n)EŐ(val)؂グۂ
#define Align_down(val, n)		(  (val)        & ~((n)-1) )	// (n)EŐ(val)؂̂Ċۂ

//! ޯĂ޲Ă̑
#define Low(data_w)				((U8)data_w)
#define High(data_w)			((U8)(data_w>>8))
#define Tst_bit_x(addrx,mask)	(*addrx & mask)
#define Set_bit_x(addrx,mask)	(*addrx = (*addrx |  mask))
#define Clr_bit_x(addrx,mask)	(*addrx = (*addrx & ~mask))

//! ߲̂߂̊l
#define  NULL					((void *)0)

//! 萔
#define ENABLE		1
#define ENABLED		1
#define DISABLED	0
#define DISABLE		0
#define FALSE		(0==1)
#define TRUE		(1==1)
#define KO			0
#define OK			1
#define CLR			0
#define SET			1
#define OFF			0
#define ON			1

//__________________________________________________________________________

#endif // _COMPILER_H_
